/**
 * If the condition type (C) extends (E), return T, else E2
 */
export declare type TypeIfType<C, E, T, T2> = [C] extends [E] ? T : T2;
/**
 * If the condition type (C) extends (E), return T, else E2
 */
export declare type TypeIfSymbol<C, T, T2> = [C] extends [symbol] ? T : T2;
/**
 * If the condition type (C) is `undefined`, return T, else T2
 */
export declare type TypeIfUndefined<C, T, T2> = [C] extends [undefined] ? T : T2;
/**
 * If the condition type (C) is `never`, return T, else C
 */
export declare type TypeIfNever<C, T> = [C] extends [never] ? T : C;
/**
 * If the condition type (C) is `never`, return `string`, else C
 */
export declare type AnyIfNever<C> = TypeIfNever<C, any>;
/**
 * If the condition type (C) is `never`, return `any`, else C
 */
export declare type StringIfNever<C> = TypeIfNever<C, string>;
